#include <windows.h>
#include "hookdef.h"
#include "..\mhook\mhook-lib\mhook.h"

typedef BOOL(WINAPI* PVirtualProtect)(
	_In_ LPVOID lpAddress,
	_In_ SIZE_T dwSize,
	_In_ DWORD flNewProtect,
	_Out_ PDWORD lpflOldProtect
	);

typedef BOOL(WINAPI* PVirtualProtectEx)(
	_In_ HANDLE hProcess,
	_In_ LPVOID lpAddress,
	_In_ SIZE_T dwSize,
	_In_ DWORD flNewProtect,
	_Out_ PDWORD lpflOldProtect
);

PVirtualProtect g_origVP     = (PVirtualProtect)  ::GetProcAddress(GetModuleHandle(TEXT("kernel32.dll")), "VirtualProtect");
PVirtualProtectEx g_origVPEx = (PVirtualProtectEx)::GetProcAddress(GetModuleHandle(TEXT("kernel32.dll")), "VirtualProtectEx"); 
bool g_hooksInstalled = false;

void InformAboutHook(void* addressFromTryToHook)
{
	wchar_t msg[50] = { 0 };
	wsprintf(msg, L"Someone is trying to hook us from %p", addressFromTryToHook);
	MessageBox(NULL, msg, L"Attention!", 0);
}

bool ProcessHook(VOID* vpAddr, VOID* callerAddress)
{
	HMODULE hmodule;	
	if (GetModuleHandleEx(GET_MODULE_HANDLE_EX_FLAG_FROM_ADDRESS | GET_MODULE_HANDLE_EX_FLAG_UNCHANGED_REFCOUNT, reinterpret_cast<LPCTSTR>(vpAddr), &hmodule)
		&& g_hooksInstalled)
	{
		InformAboutHook(callerAddress);
		return true;
	}
	return false;
}

BOOL WINAPI HookedVP(_In_ LPVOID lpAddress, _In_ SIZE_T dwSize, _In_ DWORD flNewProtect, _Out_ PDWORD lpflOldProtect)
{	
	VOID* callerAddress;
	CaptureStackBackTrace(1, 1, &callerAddress, NULL);
	return ProcessHook(lpAddress, callerAddress)
		? false
		: g_origVP(lpAddress, dwSize, flNewProtect, lpflOldProtect);
}

BOOL WINAPI HookedVPEx(_In_ HANDLE hProcess, _In_ LPVOID lpAddress, _In_ SIZE_T dwSize, _In_ DWORD flNewProtect, _Out_ PDWORD lpflOldProtect)
{
	VOID* callerAddress;
	CaptureStackBackTrace(1, 1, &callerAddress, NULL);
	return ProcessHook(lpAddress, callerAddress)
		   ? false
		   : g_origVPEx(hProcess, lpAddress, dwSize, flNewProtect, lpflOldProtect);	
}

bool SetHooks()
{	
	return Mhook_SetHook((PVOID*)&g_origVP, HookedVP) &&
		   Mhook_SetHook((PVOID*)&g_origVPEx, HookedVPEx);
}

void ResetHooks()
{
	g_hooksInstalled = false;
	Mhook_Unhook((PVOID*)&g_origVP);
	Mhook_Unhook((PVOID*)&g_origVPEx);
}

HookDef::~HookDef()
{
	ResetHooks();
}

bool HookDef::Init()
{	
	return (g_hooksInstalled = SetHooks());	 
}